net.sf.saxon.event

## Class TeeOutputter

- java.lang.Object
- - net.sf.saxon.event.SequenceReceiver
  - - net.sf.saxon.event.TeeOutputter

- All Implemented Interfaces:
    Result, Receiver
  Direct Known Subclasses:
    AssertionTreeBuilder

      public class TeeOutputter
      extends SequenceReceiver

  TeeOutputter: a SequenceReceiver that duplicates received events to two different destinations

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.SequenceReceiver

      `pipelineConfiguration, previousAtomic, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TeeOutputter(Receiver seq1, Receiver seq2)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `append(Item item, int locationId, int copyNamespaces)` Output an item (atomic value or node) to the sequence
    `void` | `attribute(NodeName nameCode, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
    `void` | `characters(CharSequence chars, int locationId, int properties)` Notify character data.
    `void` | `close()` Notify the end of the event stream
    `void` | `comment(CharSequence content, int locationId, int properties)` Notify a comment.
    `void` | `endDocument()` Notify the end of a document node
    `void` | `endElement()` Notify the end of an element.
    `protected Receiver` | `getFirstDestination()` Get the first destination
    `protected Receiver` | `getSecondDestination()` Get the second destination
    `void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
    `void` | `open()` Start the output process
    `void` | `processingInstruction(String name, CharSequence data, int locationId, int properties)` Output a processing instruction
    `protected void` | `setFirstDestination(Receiver seq1)` Set the first destination
    `protected void` | `setSecondDestination(Receiver seq2)` Set the second destination
    `void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
    `void` | `startDocument(int properties)` Notify the start of a document node
    `void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` Notify the start of an element
    `boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

    - ### Methods inherited from class net.sf.saxon.event.SequenceReceiver

      `append, getConfiguration, getNamePool, getPipelineConfiguration, getSystemId, setPipelineConfiguration, setSystemId, setUnparsedEntity`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TeeOutputter

          public TeeOutputter(Receiver seq1,
                      Receiver seq2)

  - ### Method Detail

    - #### setFirstDestination

          protected void setFirstDestination(Receiver seq1)

      Set the first destination
      Parameters:
        `seq1` - the first output destination

    - #### setSecondDestination

          protected void setSecondDestination(Receiver seq2)

      Set the second destination
      Parameters:
        `seq2` - the second output destination

    - #### getFirstDestination

          protected Receiver getFirstDestination()

      Get the first destination
      Returns:
        the first output destination

    - #### getSecondDestination

          protected Receiver getSecondDestination()

      Get the second destination
      Returns:
        the second output destination

    - #### append

          public void append(Item item,
                    int locationId,
                    int copyNamespaces)
                      throws XPathException

      Output an item (atomic value or node) to the sequence
      Specified by:
        `append` in class `SequenceReceiver`
      Parameters:
        `item` - the item to be appended
        `locationId` - the location of the calling instruction, for diagnostics
        `copyNamespaces` - if the item is an element node, this indicates whether its namespaces need to be copied. Values are `NodeInfo.ALL_NAMESPACES`, `NodeInfo.LOCAL_NAMESPACES`, `NodeInfo.NO_NAMESPACES`
      Throws:
        `XPathException` - if the operation fails

    - #### open

          public void open()
                    throws XPathException

      Description copied from class: `SequenceReceiver`
      Start the output process
      Specified by:
        `open` in interface `Receiver`
      Overrides:
        `open` in class `SequenceReceiver`
      Throws:
        `XPathException` - if an error occurs

    - #### startDocument

          public void startDocument(int properties)
                             throws XPathException

      Notify the start of a document node
      Parameters:
        `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Notify the end of a document node
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement(NodeName nameCode,
                          SchemaType typeCode,
                          int locationId,
                          int properties)
                            throws XPathException

      Notify the start of an element
      Parameters:
        `nameCode` - integer code identifying the name of the element within the name pool.
        `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xs:untyped.
        `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
        `properties` - bit-significant properties of the element node. If there are no revelant
      Throws:
        `XPathException` - if an error occurs

    - #### namespace

          public void namespace(NamespaceBinding namespaceBinding,
                       int properties)
                         throws XPathException

      Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.
      Parameters:
        `namespaceBinding` - the prefix/uri pair
        `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
      Throws:
        `IllegalStateException:` - attempt to output a namespace when there is no open element start tag
        `XPathException` - if an error occurs

    - #### attribute

          public void attribute(NodeName nameCode,
                       SimpleType typeCode,
                       CharSequence value,
                       int locationId,
                       int properties)
                         throws XPathException

      Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.
      Parameters:
        `nameCode` - The name of the attribute, as held in the name pool
        `typeCode` - The type of the attribute, as held in the name pool
        `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
        `properties` - Bit significant value. The following bits are defined:
      DISABLE_ESCAPING
        Disable escaping for this attribute
      NO_SPECIAL_CHARACTERS
        Attribute value contains no special characters
        `value` - the string value of the attribute
      Throws:
        `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
        `XPathException` - if an error occurs

    - #### startContent

          public void startContent()
                            throws XPathException

      Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.
      Throws:
        `XPathException` - if an error occurs

    - #### endElement

          public void endElement()
                          throws XPathException

      Notify the end of an element. The receiver must maintain a stack if it needs to know which element is ending.
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public void characters(CharSequence chars,
                        int locationId,
                        int properties)
                          throws XPathException

      Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.
      Parameters:
        `chars` - The characters
        `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
        `properties` - Bit significant value. The following bits are defined:
      DISABLE_ESCAPING
        Disable escaping for this text node
      USE_CDATA
        Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### processingInstruction

          public void processingInstruction(String name,
                                   CharSequence data,
                                   int locationId,
                                   int properties)
                                     throws XPathException

      Output a processing instruction
      Parameters:
        `name` - The PI name. This must be a legal name (it will not be checked).
        `data` - The data portion of the processing instruction
        `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
        `properties` - Additional information about the PI. The following bits are defined:
      CHECKED
        Data is known to be legal (e.g. doesn't contain "?>")
      Throws:
        `IllegalArgumentException:` - the content is invalid for an XML processing instruction
        `XPathException` - if an error occurs

    - #### comment

          public void comment(CharSequence content,
                     int locationId,
                     int properties)
                       throws XPathException

      Notify a comment. Comments are only notified if they are outside the DTD.
      Parameters:
        `content` - The content of the comment
        `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
        `properties` - Additional information about the comment. The following bits are defined:
      CHECKED
        Comment is known to be legal (e.g. doesn't contain "--")
      Throws:
        `IllegalArgumentException:` - the content is invalid for an XML comment
        `XPathException` - if an error occurs

    - #### close

          public void close()
                     throws XPathException

      Notify the end of the event stream
      Throws:
        `XPathException` - if an error occurs

    - #### usesTypeAnnotations

          public boolean usesTypeAnnotations()

      Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events
      Returns:
        true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.